;---------------------------------------------------------------
; RetroForth/4u 8.0
;---------------------------------------------------------------
include "macros.fasm"

use32
        ORG   0x200000

        jmp   MAIN
        db    'DEX1' 

MAIN:
	mov   edi,calltable
	mov   al,0
	mov   ah,0x0a
	int   40h

	cli
	mov ebp, esp
        call vClear
        call vHome
        call init_retroforth
        upop ebx
        jmp ebx
;---------------------------------------------------------------
code 'bye', bye
	vector
	sti
	mov esp, ebp
next
;---------------------------------------------------------------
; ( KEY, a generic keyboard driver )
code 'key', key
	vector
	dup			        ; key
	  xor eax,eax	        ;  clear eax
.a:	 in al,64h		 ;  Is any data waiting?
	  test al,1		        ;  Is character = ASCII 0?
	  jz .a 	        ;  Yes? Try again
	in al,60h	        ;  Otherwise, read scancode
	xor edx,edx	        ;  edx: 0=make, 1=break
	test al,80h	        ;  Is character = HEX 80h?
	jz .b		        ;  Skip the next line
	inc edx 	        ;  Update edx
.b:	 and al,7Fh		 ;  Filters to handle
	cmp al,39h	        ;  the ignored keys
	  ja .a 	        ;  We just try another key
	mov ecx,[board]         ;  Load the keymap
	mov al,[ecx+eax]        ;  Get the key ASCII char
	  or al,al		        ;  Is is = 0?
	js .shift		        ;  No, use CAPITALS
	jz .a		        ;  Ignore 0's
	or dl,dl		        ;  Filter for break code
	jnz .a		        ;  Ignore break code
	dup
	call emit
	  ret
.shift:  mov ecx,[edx*4 + .shifts]	 ;  Load the CAPITAL keymap
	mov [board],ecx 	        ;  Store into BOARD pointer
	jmp .a			  ;  And try again
.shifts dd shift,alpha
board dd alpha
alpha:
  db 0,27,"1234567890-=",8	        ;00-0E
  db 9,"qwertyuiop[]",10	        ;0F-1C
  db 0,"asdfghjkl;'`"		        ;1D-29
  db -1,"\zxcvbnm,./",-1,"*",0,32,-2    ;2A-3A
shift:
  db 0,27,"!@#$%^&*()_+",8	        ;00-0E
  db 9,"QWERTYUIOP{}",10	        ;0F-1C
  db 0,'ASDFGHJKL:"~'		        ;1D-29
  db -1,"|ZXCVBNM<>?",-1,"*",0,32,-2    ;2A-3A
;---------------------------------------------------------------
code 'type', type
	vector
	push  es
        push   ax
        mov   ax,8h                          
	mov   es,ax                          
        pop   ax	
        upop    ebx
        call    vType
        drop
	pop	es
next

code 'emit', emit
	vector
	push  es
        push   ax
        mov   ax,8h                          
	mov   es,ax                          
        pop   ax	
        call    vEmit
        drop
	pop	es
next

code 'home', _home
        call    vHome
next

code 'scr_size', _scr_size
        upsh    [video_width]
        upsh    [video_height]
        embed   '*'
next

code 'attr', _attr
        upsh    video_attributes
next
code 'setAttr', _setattr
        upop ebx
        call vChangeAttributes
        drop
next
;---------------------------------------------------------------
_eax dd 0
_ebx dd 0
_ecx dd 0
_edx dd 0
_esi dd 0
_edi dd 0
_fun dd 0

code 'syscall', do_syscall
  embed '4 *'
  sti
  upop [_fun]
  upop [_eax]
  upop [_ebx]
  upop [_ecx]
  upop [_edx]
  upop [_esi]
  upop [_edi]
  pusha
    mov eax, [_eax]
    mov ebx, [_ebx]
    mov ecx, [_ecx]
    mov edx, [_edx]
    mov esi, [_esi]
    mov edi, [_edi]
    mov ebp, calltable
    add ebp, dword [_fun]
    call dword [ebp]
    mov [_eax], eax
    mov [_ebx], ebx
    mov [_ecx], ecx
    mov [_edx], edx
    mov [_esi], esi
    mov [_edi], edi
  popa
  upsh [_edi]
  upsh [_esi]
  upsh [_edx]
  upsh [_ecx]
  upsh [_ebx]
  upsh [_eax]
  cli
next
;---------------------------------------------------------------
include "util.asm"
include "video.asm"
;---------------------------------------------------------------
include "core.asm"
calltable rb 0
